"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = render;

var _react = _interopRequireDefault(require("react"));

var _location = require("../../location");

var _router = require("../../router");

var _createRouterElement = _interopRequireDefault(require("../../router/client/createRouterElement"));

var _flags = require("../../client/flags");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function render(_ref) {
  var store = _ref.store;
  return (0, _router.matchRoutes)(store).then(function (renderArgs) {
    // The first pass of initial client-side render
    // was to render the markup which matches server-side one.
    // The second pass will be to render after resolving `getData`.
    if ((0, _flags.isServerSidePreloaded)()) {
      window._react_pages_initial_prerender = false;
      window._react_pages_skip_preload = false;
    } // `routes` are used when comparing `instantBack` chain items
    // for resetting `instantBack` chain when the same route is encountered twice.


    window._react_pages_route_components = renderArgs.routeIndices;
    return {
      element: (0, _createRouterElement["default"])(renderArgs, store),
      containerProps: {
        store: store
      },
      store: store
    };
  });
}
//# sourceMappingURL=render.js.map