"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = createPreloadReducer;

var _actions = require("./actions");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function createPreloadReducer() {
  var showInitially = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
      initial: showInitially,
      pending: showInitially,
      immediate: showInitially
    };
    var action = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    switch (action.type) {
      case _actions.PRELOAD_STARTED:
        return _objectSpread({}, state, {
          pending: true,
          immediate: action.immediate || false,
          error: undefined
        });

      case _actions.PRELOAD_FINISHED:
        return _objectSpread({}, state, {
          pending: false,
          immediate: false,
          initial: false
        });

      case _actions.PRELOAD_FAILED:
        return _objectSpread({}, state, {
          pending: false,
          immediate: false,
          initial: false,
          error: action.error
        });

      default:
        return state;
    }
  };
}
//# sourceMappingURL=reducer.js.map