"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = download;

var _http = _interopRequireDefault(require("http"));

var _https = _interopRequireDefault(require("https"));

// Downloads a URL resolving to its text contents
function download(url) {
  return new Promise(function (resolve, reject) {
    var secure = typeof url === 'string' ? url.indexOf('https://') === 0 : url.protocol === 'https:';
    var request = (secure ? _https["default"] : _http["default"]).request(url, function (response) {
      response.setEncoding('utf8');
      var response_body = '';
      response.on('data', function (chunk) {
        return response_body += chunk;
      });
      response.on('end', function () {
        return resolve({
          status: response.statusCode,
          content: response_body
        });
      });
    });
    request.on('error', reject);
    request.end();
  });
}
//# sourceMappingURL=download.js.map