"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = walk;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

/**
 * Returns the paths to all files in a directory.
 * (walks the subdirectory tree recursively).
 */
function walk(dir) {
  return new Promise(function (resolve, reject) {
    _fs["default"].readdir(dir, function (error, files) {
      if (error) {
        return reject(error);
      }

      Promise.all(files.map(function (file) {
        return new Promise(function (resolve, reject) {
          var filepath = _path["default"].join(dir, file);

          _fs["default"].stat(filepath, function (error, stats) {
            if (error) {
              return reject(error);
            }

            if (stats.isDirectory()) {
              walk(filepath).then(resolve);
            } else if (stats.isFile()) {
              resolve(filepath);
            }
          });
        });
      })).then(function (foldersContents) {
        resolve(foldersContents.reduce(function (all, folderContents) {
          return all.concat(folderContents);
        }, []));
      });
    });
  });
}
//# sourceMappingURL=walk.js.map