function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useCallback } from 'react';
import PropTypes from 'prop-types';
import Link from 'found/Link';
import { markImmediateNavigationAsInstantBack } from './client/instantBack';
export default function HyperLink(_ref) {
  var instantBack = _ref.instantBack,
      onClick = _ref.onClick,
      rest = _objectWithoutProperties(_ref, ["instantBack", "onClick"]);

  var onClickHandler = useCallback(function (event) {
    if (onClick) {
      onClick(event);
    }

    if (event.defaultPrevented) {
      return;
    }

    markImmediateNavigationAsInstantBack(instantBack);
  }, [instantBack, onClick]);
  return React.createElement(Link, _extends({}, rest, {
    onClick: onClickHandler
  }));
}
HyperLink.propTypes = {
  instantBack: PropTypes.bool,
  onClick: PropTypes.func
};
//# sourceMappingURL=Link.js.map