function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { collectPreloadersFromComponents } from './preload';
import { PRELOAD_METHOD_NAME } from './decorator';
describe("load", function () {
  it("should collect preloaders from React Components", function () {
    var preload_1 = function preload_1() {};

    var preload_2 = function preload_2() {};

    var preload_3 = function preload_3() {};

    collectPreloadersFromComponents([null, _defineProperty({}, PRELOAD_METHOD_NAME, [{
      load: preload_1,
      client: true
    }]), undefined, _defineProperty({}, PRELOAD_METHOD_NAME, [{
      load: preload_2,
      blocking: false
    }, {
      load: preload_3,
      server: true
    }]), {}]).should.deep.equal([[{
      preload: preload_1,
      options: {
        client: true
      }
    }], [{
      preload: preload_2,
      options: {
        blocking: false
      }
    }, {
      preload: preload_3,
      options: {
        server: true
      }
    }]]);
  });
});
//# sourceMappingURL=preload.test.js.map