import http from 'http';
import https from 'https'; // Downloads a URL resolving to its text contents

export default function download(url) {
  return new Promise(function (resolve, reject) {
    var secure = typeof url === 'string' ? url.indexOf('https://') === 0 : url.protocol === 'https:';
    var request = (secure ? https : http).request(url, function (response) {
      response.setEncoding('utf8');
      var response_body = '';
      response.on('data', function (chunk) {
        return response_body += chunk;
      });
      response.on('end', function () {
        return resolve({
          status: response.statusCode,
          content: response_body
        });
      });
    });
    request.on('error', reject);
    request.end();
  });
}
//# sourceMappingURL=download.js.map